Я использую Boost :: thread для реализации класса InterruptibleThread, но при этом получаю ошибку сегментации во время выполнения. Любая идея?

Источник и результат находятся ниже.

interruptiblethread.h

#ifndef INTERRUPTIBLETHREAD_H
#define INTERRUPTIBLETHREAD_H

#include <boost/thread.hpp>
#include <boost/thread/future.hpp>
#include <boost/thread/tss.hpp>

class InterruptFlag
{
public:
    inline void set()
    {
        boost::lock_guard<boost::mutex> guard(_mtx);
        _set = true;
    }

    inline bool is_set()
    {
        std::cout << "is_set()" << std::endl;
        boost::lock_guard<boost::mutex> guard(_mtx);
        std::cout << "is_set() end" << std::endl;       
        return _set;
    }

private:
    boost::mutex _mtx;
    bool _set;
};

extern boost::thread_specific_ptr<InterruptFlag> this_thread_interrupt_flag;

class InterruptibleThread
{
public:
    template<typename FunctionType>
    InterruptibleThread(FunctionType f)
    {
        boost::promise<InterruptFlag*> p;
        _internal_thread = boost::thread([f, &p]()
        {
            p.set_value(this_thread_interrupt_flag.get());
            f();
        });
        _interrupt_flag = p.get_future().get();
    }

    inline void interrupt()
    {
        if (_interrupt_flag != nullptr)
        {
            _interrupt_flag->set();
        }
    }

private:
    boost::thread _internal_thread;
    InterruptFlag* _interrupt_flag;
};

#endif // INTERRUPTIBLETHREAD_H

interruptiblethread.cpp

#include <iostream>
#include <functional>

#include "interruptiblethread.h"

using std::cout; using std::endl;
using std::function;

boost::thread_specific_ptr<InterruptFlag> this_thread_interrupt_flag;

struct thread_interrupted {};

void interruption_point()
{
    cout << "interruption_point()" << endl;
    if (this_thread_interrupt_flag->is_set())
    {
        cout << "is_set" << endl;       
        throw thread_interrupted();
    }
}

void foo()
{
    while (true)
    {
        cout << "iterate" << endl;
        try
        {
            interruption_point();
        } catch (const thread_interrupted& interrupt)
        {
            cout << "catch thread_interrupted" << endl;
            break;
        }
    }
}

int main()
{
    InterruptibleThread int_thread(foo);
    int_thread.interrupt();
    while (true) {}
}

Выход:

➜  build ./main
iterate
interruption_point()
is_set()
[1]    44435 segmentation fault  ./main
0
Qi W. 23 Фев 2016 в 17:58
1
this_thread_interrupt_flag никогда не "инициализируется" - он все еще содержит nullptr?
 – 
Simon Kraemer
23 Фев 2016 в 18:08
Спасибо чувак. Я думаю, что он был инициализирован, потому что он имеет вывод is_set (). Хотя я в этом не уверен.
 – 
Qi W.
23 Фев 2016 в 18:23
Я так не думаю. Я думаю, что он не инициализирован, и ваш вызов is_set - UB. Проверьте этот вопрос: stackoverflow.com/questions / 6021273 /…
 – 
Simon Kraemer
23 Фев 2016 в 18:25
Ага, работает! Это действительно необходимо для инициализации this_thread_interrupt_flag. Спасибо большое!
 – 
Qi W.
23 Фев 2016 в 18:39

1 ответ

Лучший ответ

this_thread_interrupt_flag не инициализирован. Пожалуйста, инициализируйте его правильно, как описано здесь

Ваш звонок в is_set - UB.

1
Community 23 Май 2017 в 14:50